diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBColorDlg.cpp ./src/win32/GBColorDlg.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBColorDlg.cpp	2004-05-13 23:26:06 +0900
+++ ./src/win32/GBColorDlg.cpp	2006-05-27 23:47:33 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -32,28 +32,31 @@
 
 static u16 defaultPalettes[][24] = {
   {
-    0x7FFF, 0x56B5, 0x318C, 0x0000, 0x7FFF, 0x56B5, 0x318C, 0x0000,
+    0x7FFF, 0x56B5, 0x318C, 0x0000,  0x7FFF, 0x56B5, 0x318C, 0x0000,
   },
   {
-    0x6200, 0x7E10, 0x7C10, 0x5000, 0x6200, 0x7E10, 0x7C10, 0x5000,
+    0x6200, 0x7E10, 0x7C10, 0x5000,  0x6200, 0x7E10, 0x7C10, 0x5000,
   },
   {
-    0x4008, 0x4000, 0x2000, 0x2008, 0x4008, 0x4000, 0x2000, 0x2008, 
+    0x4008, 0x4000, 0x2000, 0x2008,  0x4008, 0x4000, 0x2000, 0x2008, 
   },
   {
-    0x43F0, 0x03E0, 0x4200, 0x2200, 0x43F0, 0x03E0, 0x4200, 0x2200, 
+    0x43F0, 0x03E0, 0x4200, 0x2200,  0x43F0, 0x03E0, 0x4200, 0x2200, 
   },
   {
-    0x43FF, 0x03FF, 0x221F, 0x021F, 0x43FF, 0x03FF, 0x221F, 0x021F, 
+    0x43FF, 0x03FF, 0x221F, 0x021F,  0x43FF, 0x03FF, 0x221F, 0x021F, 
   },
   {
-    0x621F, 0x7E1F, 0x7C1F, 0x2010, 0x621F, 0x7E1F, 0x7C1F, 0x2010, 
+    0x621F, 0x7E1F, 0x7C1F, 0x2010,  0x621F, 0x7E1F, 0x7C1F, 0x2010, 
   },
   {
-    0x621F, 0x401F, 0x001F, 0x2010, 0x621F, 0x401F, 0x001F, 0x2010, 
+    0x621F, 0x401F, 0x001F, 0x2010,  0x621F, 0x401F, 0x001F, 0x2010, 
   },
   {
-    0x421F, 0x03E0, 0x7C00, 0x401F, 0x021F, 0x2200, 0x4008, 0x2010, 
+    0x1B8E, 0x02C0, 0x0DA0, 0x1140,  0x1B8E, 0x02C0, 0x0DA0, 0x1140, 
+  },
+  {
+    0x7BDE, /*0x23F0*/ 0x5778, /*0x5DC0*/ 0x5640, 0x0000,  0x7BDE, /*0x3678*/ 0x529C, /*0x0980*/ 0x2990, 0x0000, 
   }
 };
 
@@ -70,20 +73,15 @@
 GBColorDlg::GBColorDlg(CWnd* pParent /*=NULL*/)
   : CDialog(GBColorDlg::IDD, pParent)
 {
-  //{{AFX_DATA_INIT(GBColorDlg)
-  which = -1;
-  //}}AFX_DATA_INIT
   which = gbPaletteOption;
 }
 
 
 void GBColorDlg::DoDataExchange(CDataExchange* pDX)
 {
-  CDialog::DoDataExchange(pDX);
-  //{{AFX_DATA_MAP(GBColorDlg)
+	CDialog::DoDataExchange(pDX);
 	DDX_Control(pDX, IDC_PREDEFINED, m_predefined);
-  DDX_Radio(pDX, IDC_DEFAULT, which);
-	//}}AFX_DATA_MAP
+	DDX_Radio(pDX, IDC_DEFAULT, which);
 }
 
 
@@ -95,8 +93,8 @@
   ON_BN_CLICKED(IDC_USER2, OnUser2)
   ON_BN_CLICKED(ID_OK, OnOk)
   ON_BN_CLICKED(ID_CANCEL, OnCancel)
-	ON_CBN_SELCHANGE(IDC_PREDEFINED, OnSelchangePredefined)
-	//}}AFX_MSG_MAP
+  ON_CBN_SELCHANGE(IDC_PREDEFINED, OnSelchangePredefined)
+  //}}AFX_MSG_MAP
   ON_CONTROL_RANGE(BN_CLICKED, IDC_COLOR_BG0, IDC_COLOR_OB3, OnColorClicked)
   END_MESSAGE_MAP()
 
@@ -167,10 +165,12 @@
     "Green Forest",
     "Hot Desert",
     "Pink Dreams",
-    "Weird Colors"
+    "Weird Colors",
+	"Real GB Colors",
+    "Real 'GB on GBASP' Colors"
   };
 
-  for(int j = 0; j < 7; j++) {
+  for(int j = 0; j < 9; j++) {
     int index = m_predefined.AddString(names[j]);
     m_predefined.SetItemData(index, j);
   }
@@ -222,15 +222,20 @@
 {
   id -= IDC_COLOR_BG0;
   
-  u16 color = colors[id];
+  u16 color = colors[which*8+id];
+
+  COLORREF colorInit =
+	  RGB((color & 0x1f) << 3, ((color >> 5) & 0x1f) << 3, ((color >> 10) & 0x1f) << 3);
 
-  CColorDialog dlg(RGB(color & 0x1f, (color >> 5) & 0x1f, (color >> 10) & 0x1f),
+  CColorDialog dlg(colorInit,
                    CC_FULLOPEN | CC_ANYCOLOR, this);
-  if(dlg.DoModal()) {
+
+  if(IDOK == dlg.DoModal())
+  {
     COLORREF c = dlg.GetColor();
     
-    colors[which*8+id] = (u16)((c >> 3) & 0x1f | ((c >> 11) & 0x1f) << 5 |
-                               ((c >> 19) & 0x1f) << 10);
+    colors[which*8+id] = (u16)((c >> 3) & 0x1f | ((c >> 11) & 0x1f) << 5 | ((c >> 19) & 0x1f) << 10);
+
     colorControls[id].setColor(colors[which*8+id]);
   }  
 }
@@ -246,7 +251,7 @@
 	int sel = m_predefined.GetCurSel();
 
   if(sel != -1) {
-    int data = m_predefined.GetItemData(sel);
+    DWORD_PTR data = m_predefined.GetItemData(sel);
     for(int i = 0; i < 8; i++) {
       colorControls[i].setColor(defaultPalettes[data][i]);
       colors[which*8+i] = defaultPalettes[data][i];
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBColorDlg.h ./src/win32/GBColorDlg.h
--- ../VisualBoyAdvance-1.7.2/src/win32/GBColorDlg.h	2004-05-13 22:45:01 +0900
+++ ./src/win32/GBColorDlg.h	2006-05-27 23:47:33 +0900
@@ -21,7 +21,7 @@
 #define AFX_GBCOLORDLG_H__8D6126EF_06BB_48CF_ABB3_2CC4B1B60358__INCLUDED_
 
 #include "ColorButton.h"  // Added by ClassView
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBDisassemble.cpp ./src/win32/GBDisassemble.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBDisassemble.cpp	2004-05-13 23:25:55 +0900
+++ ./src/win32/GBDisassemble.cpp	2006-01-05 00:10:33 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -39,6 +39,7 @@
 extern gbRegister HL;
 extern gbRegister SP;
 extern gbRegister PC;
+extern u8 register_LY;
 extern u16 IFF;
 extern int gbDis(char *, u16);
 
@@ -114,8 +115,9 @@
 void GBDisassemble::OnGo() 
 {
   CString buffer;
+
   m_address.GetWindowText(buffer);
-  sscanf(buffer, "%x", &address);
+  sscanf(buffer, "%hx", &address);
   refresh();
 }
 
@@ -242,6 +244,8 @@
   GetDlgItem(IDC_R5)->SetWindowText(buffer);  
   sprintf(buffer, "%04x", IFF);
   GetDlgItem(IDC_R6)->SetWindowText(buffer);  
+  sprintf(buffer, "%04x", register_LY);
+  GetDlgItem(IDC_LY)->SetWindowText(buffer);
 
   m_z = (AF.B.B0 & 0x80) != 0;
   m_n = (AF.B.B0 & 0x40) != 0;
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBDisassemble.h ./src/win32/GBDisassemble.h
--- ../VisualBoyAdvance-1.7.2/src/win32/GBDisassemble.h	2004-05-13 22:44:47 +0900
+++ ./src/win32/GBDisassemble.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_GBDISASSEMBLE_H__3EFD5B47_6DBF_4F63_8F91_A9511EC590EB__INCLUDED_)
 #define AFX_GBDISASSEMBLE_H__3EFD5B47_6DBF_4F63_8F91_A9511EC590EB__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBMapView.cpp ./src/win32/GBMapView.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBMapView.cpp	2004-05-13 23:25:45 +0900
+++ ./src/win32/GBMapView.cpp	2006-06-07 06:04:21 +0900
@@ -499,8 +499,8 @@
   u8 *colors = (u8 *)lParam;
   mapViewZoom.setColors(colors);
 
-  int x = wParam & 0xffff;
-  int y = (wParam >> 16);
+  int x = (int)(wParam & 0xffff);
+  int y = (int)(wParam >> 16);
   
   CString buffer;
   buffer.Format("(%d,%d)", x, y);
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBMapView.h ./src/win32/GBMapView.h
--- ../VisualBoyAdvance-1.7.2/src/win32/GBMapView.h	2004-05-13 22:44:36 +0900
+++ ./src/win32/GBMapView.h	2006-05-27 23:47:33 +0900
@@ -31,7 +31,7 @@
 #include "ZoomControl.h"
 #include "ResizeDlg.h"
 #include "IUpdate.h"
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 
 /////////////////////////////////////////////////////////////////////////////
 // GBMapView dialog
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBPaletteView.cpp ./src/win32/GBPaletteView.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBPaletteView.cpp	2004-05-13 23:25:08 +0900
+++ ./src/win32/GBPaletteView.cpp	2004-11-01 03:26:01 +0900
@@ -136,6 +136,8 @@
     return;
   }
 
+  captureBuffer = dlg.GetPathName();
+
   PaletteViewControl *p = NULL;
 
   if(which == 0)
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBTileView.cpp ./src/win32/GBTileView.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBTileView.cpp	2004-05-13 23:24:44 +0900
+++ ./src/win32/GBTileView.cpp	2006-05-27 23:47:33 +0900
@@ -460,8 +460,8 @@
   u8 *colors = (u8 *)lParam;
   zoom.setColors(colors);
 
-  int x = (wParam & 0xFFFF)/8;
-  int y = ((wParam >> 16) & 0xFFFF)/8;
+  int x = (int)((wParam & 0xffff)/8);
+  int y = (int)(((wParam >> 16) & 0xFFFF)/8);
 
   int tiles = 0x0000;
   if(charBase)
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GDIDisplay.cpp ./src/win32/GDIDisplay.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GDIDisplay.cpp	2004-05-13 23:24:10 +0900
+++ ./src/win32/GDIDisplay.cpp	2006-06-22 01:58:15 +0900
@@ -1,6 +1,7 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
 // Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -17,12 +18,14 @@
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
 #include "stdafx.h"
-#include <stdio.h>
+
+#include "Display.h"
 
 #include "../System.h"
 #include "../GBA.h"
 #include "../Globals.h"
 #include "../Text.h"
+#include "../Util.h"
 
 #include "VBA.h"
 #include "MainWnd.h"
@@ -36,7 +39,6 @@
 #endif
 
 extern void winlog(const char *,...);
-extern int RGB_LOW_BITS_MASK;
 extern int Init_2xSaI(u32);
 extern int systemSpeed;
 
@@ -216,10 +218,8 @@
     if(systemColorDepth == 16) {
       if(systemGreenShift == 6) {
         Init_2xSaI(565);
-        RGB_LOW_BITS_MASK=0x821;
       } else {
         Init_2xSaI(555);
-        RGB_LOW_BITS_MASK=0x421;        
       }
     } else if(systemColorDepth == 32)
       Init_2xSaI(32);
@@ -241,27 +241,7 @@
     cpu_mmx = 0;
 #endif
   
-  switch(systemColorDepth) {
-  case 16:
-    {
-      for(int i = 0; i < 0x10000; i++) {
-        systemColorMap16[i] = ((i & 0x1f) << systemRedShift) |
-          (((i & 0x3e0) >> 5) << systemGreenShift) |
-          (((i & 0x7c00) >> 10) << systemBlueShift);
-      }
-    }
-    break;
-  case 24:
-  case 32:
-    {
-      for(int i = 0; i < 0x10000; i++) {
-        systemColorMap32[i] = ((i & 0x1f) << systemRedShift) |
-          (((i & 0x3e0) >> 5) << systemGreenShift) |
-          (((i & 0x7c00) >> 10) << systemBlueShift);
-      }      
-    }
-    break;
-  }
+  utilUpdateSystemColorMaps();
   theApp.updateFilter();
   theApp.updateIFB();
   
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GameOverrides.cpp ./src/win32/GameOverrides.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GameOverrides.cpp	1970-01-01 09:00:00 +0900
+++ ./src/win32/GameOverrides.cpp	2006-08-02 04:21:16 +0900
@@ -0,0 +1,291 @@
+// VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
+// Copyright (C) 1999-2003 Forgotten
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
+
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; either version 2, or(at your option)
+// any later version.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software Foundation,
+// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+// GameOverrides.cpp : implementation file
+//
+
+#include "stdafx.h"
+#include "vba.h"
+#include "GameOverrides.h"
+#include "../GBA.h"
+
+#ifdef _DEBUG
+#define new DEBUG_NEW
+#undef THIS_FILE
+static char THIS_FILE[] = __FILE__;
+#endif
+
+/////////////////////////////////////////////////////////////////////////////
+// GameOverrides dialog
+
+
+GameOverrides::GameOverrides(CWnd* pParent /*=NULL*/)
+  : CDialog(GameOverrides::IDD, pParent)
+{
+  //{{AFX_DATA_INIT(GameOverrides)
+  // NOTE: the ClassWizard will add member initialization here
+  //}}AFX_DATA_INIT
+}
+
+
+void GameOverrides::DoDataExchange(CDataExchange* pDX)
+{
+	CDialog::DoDataExchange(pDX);
+	//{{AFX_DATA_MAP(GameOverrides)
+	DDX_Control(pDX, IDC_NAME, m_name);
+	DDX_Control(pDX, IDC_MIRRORING, m_mirroring);
+	DDX_Control(pDX, IDC_FLASH_SIZE, m_flashSize);
+	DDX_Control(pDX, IDC_SAVE_TYPE, m_saveType);
+	DDX_Control(pDX, IDC_RTC, m_rtc);
+	DDX_Control(pDX, IDC_COMMENT, m_comment);
+	//}}AFX_DATA_MAP
+}
+
+
+BEGIN_MESSAGE_MAP(GameOverrides, CDialog)
+  //{{AFX_MSG_MAP(GameOverrides)
+  ON_BN_CLICKED(IDC_DEFAULTS, OnDefaults)
+  //}}AFX_MSG_MAP
+  END_MESSAGE_MAP()
+
+  /////////////////////////////////////////////////////////////////////////////
+// GameOverrides message handlers
+
+void GameOverrides::OnOK() 
+{
+  char tempName[2048];
+  
+  GetModuleFileName(NULL, tempName, 2048);
+  
+  char *p = strrchr(tempName, '\\');
+  if(p)
+    *p = 0;
+  
+  char buffer[5];
+  strncpy(buffer, (const char *)&rom[0xac], 4);
+  buffer[4] = 0;
+  
+  strcat(tempName, "\\vba-over.ini");
+
+  char comment[0xFF];
+  m_comment.GetWindowText(comment, 0xFF);
+  WritePrivateProfileString(buffer, "comment", !strncmp(comment, "", 0xFF) ? NULL : comment, tempName);
+
+  int rtc = m_rtc.GetCurSel();
+  int flash = m_flashSize.GetCurSel();
+  int save = m_saveType.GetCurSel();
+  int mirroring = m_mirroring.GetCurSel();
+  if(rtc == 0 && flash == 0 && save == 0 && mirroring == 0)
+    WritePrivateProfileString(buffer, NULL, NULL, tempName);
+  else {
+    char *value = NULL;
+    switch(rtc) {
+    case 1:
+      value = "0";
+      break;
+    case 2:
+      value = "1";
+      break;
+    }
+    WritePrivateProfileString(buffer, "rtcEnabled", value, tempName);
+    value = NULL;
+    switch(flash) {
+    case 1:
+      value = "0x10000";
+      break;
+    case 2:
+      value = "0x20000";
+      break;
+    }
+    WritePrivateProfileString(buffer, "flashSize", value, tempName);
+    value = NULL;
+    switch(save) {
+    case 1:
+      value = "0";
+      break;
+    case 2:
+      value = "1";
+      break;
+    case 3:
+      value = "2";
+      break;
+    case 4:
+      value = "3";
+      break;
+    case 5:
+      value = "4";
+      break;
+    case 6:
+      value = "5";
+      break;
+    }
+    WritePrivateProfileString(buffer, "saveType", value, tempName);
+    value = NULL;
+    switch(mirroring) {
+    case 1:
+      value = "0";
+      break;
+    case 2:
+      value = "1";
+      break;
+    }
+    WritePrivateProfileString(buffer, "mirroringEnabled", value, tempName);
+  }
+  CDialog::OnOK();
+}
+
+void GameOverrides::OnDefaults() 
+{
+  m_rtc.SetCurSel(0);
+  m_flashSize.SetCurSel(0);
+  m_saveType.SetCurSel(0);
+  m_mirroring.SetCurSel(0);
+}
+
+void GameOverrides::OnCancel() 
+{
+  CDialog::OnCancel();
+}
+
+BOOL GameOverrides::OnInitDialog() 
+{
+  CDialog::OnInitDialog();
+
+  char tempName[2048];
+  
+  const char *rtcValues[] = {
+    "Default",
+    "Disabled",
+    "Enabled"
+  };
+  const char *flashValues[] = {
+    "Default",
+    "64K",
+    "128K"
+  };
+  const char *saveValues[] = {
+    "Default",
+    "Automatic",
+    "EEPROM",
+    "SRAM",
+    "Flash",
+    "EEPROM+Sensor",
+    "None"
+  };
+  const char *mirroringValues[] = {
+    "Default",
+    "Disabled",
+    "Enabled"
+  };
+
+  int i;
+
+  for(i = 0; i < 3; i++) {
+    m_rtc.AddString(rtcValues[i]);
+  }
+  for(i = 0; i < 3; i++) {
+    m_flashSize.AddString(flashValues[i]);
+  }
+  for(i = 0; i < 7; i++) {
+    m_saveType.AddString(saveValues[i]);
+  }
+  for(i = 0; i < 3; i++) {
+    m_mirroring.AddString(mirroringValues[i]);
+  }
+
+  GetModuleFileName(NULL, tempName, 2048);
+  
+  char *p = strrchr(tempName, '\\');
+  if(p)
+    *p = 0;
+  
+  char buffer[5];
+  strncpy(buffer, (const char *)&rom[0xac], 4);
+  buffer[4] = 0;
+  
+  strcat(tempName, "\\vba-over.ini");
+
+  m_name.SetWindowText(buffer);
+
+  char comment[0xFF];
+  GetPrivateProfileString(buffer,
+	  "comment",
+	  "",
+	  comment,
+	  0xFF,
+	  tempName);
+  m_comment.SetWindowText(comment);
+
+  UINT v = GetPrivateProfileInt(buffer,
+                                "rtcEnabled",
+                                -1,
+                                tempName);
+  switch(v) {
+  case 0:
+    m_rtc.SetCurSel(1);
+    break;
+  case 1:
+    m_rtc.SetCurSel(2);
+    break;
+  default:
+    m_rtc.SetCurSel(0);
+  }
+  v = GetPrivateProfileInt(buffer,
+                           "flashSize",
+                           -1,
+                           tempName);
+  switch(v) {
+  case 0x10000:
+    m_flashSize.SetCurSel(1);
+    break;
+  case 0x20000:
+    m_flashSize.SetCurSel(2);
+    break;
+  default:
+    m_flashSize.SetCurSel(0);
+  }
+  
+  v = GetPrivateProfileInt(buffer,
+                           "saveType",
+                           -1,
+                           tempName);
+  if(v != (UINT)-1 && (v > 5))
+    v = (UINT)-1;
+  if(v != (UINT)-1)
+    m_saveType.SetCurSel(v+1);
+  else
+    m_saveType.SetCurSel(0);
+  
+  v = GetPrivateProfileInt(buffer,
+                           "mirroringEnabled",
+                            -1,
+                            tempName);
+  switch(v) {
+  case 0:
+    m_mirroring.SetCurSel(1);
+    break;
+  case 1:
+    m_mirroring.SetCurSel(2);
+    break;
+  default:
+    m_mirroring.SetCurSel(0);
+  }
+
+  return TRUE;  // return TRUE unless you set the focus to a control
+  // EXCEPTION: OCX Property Pages should return FALSE
+}
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GameOverrides.h ./src/win32/GameOverrides.h
--- ../VisualBoyAdvance-1.7.2/src/win32/GameOverrides.h	1970-01-01 09:00:00 +0900
+++ ./src/win32/GameOverrides.h	2006-08-02 04:21:16 +0900
@@ -0,0 +1,74 @@
+// VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
+// Copyright (C) 1999-2003 Forgotten
+// Copyright (C) 2005 Forgotten and the VBA development team
+
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; either version 2, or(at your option)
+// any later version.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software Foundation,
+// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+#include "afxwin.h"
+#if !defined(AFX_GAMEOVERRIDES_H__EEEFE37F_F477_455D_8682_705FB2DBCC0C__INCLUDED_)
+#define AFX_GAMEOVERRIDES_H__EEEFE37F_F477_455D_8682_705FB2DBCC0C__INCLUDED_
+
+#if _MSC_VER > 1000
+#pragma once
+#endif // _MSC_VER > 1000
+// GameOverrides.h : header file
+//
+
+/////////////////////////////////////////////////////////////////////////////
+// GameOverrides dialog
+
+class GameOverrides : public CDialog
+{
+// Construction
+public:
+	GameOverrides(CWnd* pParent = NULL);   // standard constructor
+
+// Dialog Data
+	//{{AFX_DATA(GameOverrides)
+	enum { IDD = IDD_GAME_OVERRIDES };
+	CEdit	m_name;
+	CComboBox	m_mirroring;
+	CComboBox	m_flashSize;
+	CComboBox	m_saveType;
+	CComboBox	m_rtc;
+	//}}AFX_DATA
+
+
+// Overrides
+	// ClassWizard generated virtual function overrides
+	//{{AFX_VIRTUAL(GameOverrides)
+	protected:
+	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
+	//}}AFX_VIRTUAL
+
+// Implementation
+protected:
+
+	// Generated message map functions
+	//{{AFX_MSG(GameOverrides)
+	virtual void OnOK();
+	afx_msg void OnDefaults();
+	virtual void OnCancel();
+	virtual BOOL OnInitDialog();
+	//}}AFX_MSG
+	DECLARE_MESSAGE_MAP()
+public:
+	CEdit m_comment;
+};
+
+//{{AFX_INSERT_LOCATION}}
+// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
+
+#endif // !defined(AFX_GAMEOVERRIDES_H__EEEFE37F_F477_455D_8682_705FB2DBCC0C__INCLUDED_)
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/IOViewer.cpp ./src/win32/IOViewer.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/IOViewer.cpp	2004-05-13 23:23:37 +0900
+++ ./src/win32/IOViewer.cpp	2005-06-25 15:23:31 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -67,6 +67,22 @@
   ON_BN_CLICKED(IDC_AUTO_UPDATE, OnAutoUpdate)
   ON_CBN_SELCHANGE(IDC_ADDRESSES, OnSelchangeAddresses)
 	ON_BN_CLICKED(IDC_APPLY, OnApply)
+  ON_BN_CLICKED(IDC_BIT_0, bitChange)
+  ON_BN_CLICKED(IDC_BIT_1, bitChange)
+  ON_BN_CLICKED(IDC_BIT_2, bitChange)
+  ON_BN_CLICKED(IDC_BIT_3, bitChange)
+  ON_BN_CLICKED(IDC_BIT_4, bitChange)
+  ON_BN_CLICKED(IDC_BIT_5, bitChange)
+  ON_BN_CLICKED(IDC_BIT_6, bitChange)
+  ON_BN_CLICKED(IDC_BIT_7, bitChange)
+  ON_BN_CLICKED(IDC_BIT_8, bitChange)
+  ON_BN_CLICKED(IDC_BIT_9, bitChange)
+  ON_BN_CLICKED(IDC_BIT_10, bitChange)
+  ON_BN_CLICKED(IDC_BIT_11, bitChange)
+  ON_BN_CLICKED(IDC_BIT_12, bitChange)
+  ON_BN_CLICKED(IDC_BIT_13, bitChange)
+  ON_BN_CLICKED(IDC_BIT_14, bitChange)
+  ON_BN_CLICKED(IDC_BIT_15, bitChange)
 	//}}AFX_MSG_MAP
   END_MESSAGE_MAP()
 
@@ -80,10 +96,29 @@
   DestroyWindow();
 }
 
+void IOViewer::bitChange() 
+{
+  CString buffer;
+  u16 data = 0;
+
+  for(int i = 0; i < 16; i++) {
+    CButton *pWnd = (CButton *)GetDlgItem(IDC_BIT_0 + i);
+	  
+    if(pWnd) {
+      if(pWnd->GetCheck())
+        data |= (1 << i);
+    }
+  }
+
+  buffer.Format("%04X", data);
+  m_value.SetWindowText(buffer);
+}
+
 void IOViewer::OnRefresh() 
 {
   // TODO: Add your control notification handler code here
-  
+
+  update();  
 }
 
 void IOViewer::OnAutoUpdate() 
@@ -186,6 +221,8 @@
 
 void IOViewer::OnApply() 
 {
+  if(rom != NULL)
+  {
   const IOData *sel = &ioViewRegisters[selected];
   u16 res = 0;
   for(int i = 0; i < 16; i++) {
@@ -198,4 +235,5 @@
   }
   CPUWriteHalfWord(0x4000000+sel->offset, res);
   update();
+  }
 }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/IOViewer.h ./src/win32/IOViewer.h
--- ../VisualBoyAdvance-1.7.2/src/win32/IOViewer.h	2004-05-13 22:42:26 +0900
+++ ./src/win32/IOViewer.h	2005-06-25 15:23:31 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -37,6 +37,7 @@
   // Construction
  public:
   void update();
+  void bitChange();
   bool autoUpdate;
   int selected;
   IOViewer(CWnd* pParent = NULL);   // standard constructor
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/IOViewerRegs.h ./src/win32/IOViewerRegs.h
--- ../VisualBoyAdvance-1.7.2/src/win32/IOViewerRegs.h	2004-05-13 22:42:00 +0900
+++ ./src/win32/IOViewerRegs.h	2005-06-25 15:23:31 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -258,7 +258,7 @@
     }
   },
   {
-    &BG2HOFS, 0x18, "0x4000018-BG8HOFS", 0x01FF,
+    &BG2HOFS, 0x18, "0x4000018-BG2HOFS", 0x01FF,
     {
       "",
       "",
@@ -1119,7 +1119,7 @@
     }
   },
   {
-    NULL, 0x82, "0x4000082-SGCNT0_H", 0xFF1F,
+    NULL, 0x82, "0x4000082-SGCNT0_H", 0xFF0F,
     {
       "",
       "Sound 1-4 Volume (2 bits)",
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Input.h ./src/win32/Input.h
--- ../VisualBoyAdvance-1.7.2/src/win32/Input.h	2004-05-13 22:41:34 +0900
+++ ./src/win32/Input.h	2006-06-07 06:04:21 +0900
@@ -43,7 +43,7 @@
 
   virtual bool readDevices() = 0;
   virtual u32 readDevice(int which) = 0;
-  virtual CString getKeyName(int key) = 0;
+  virtual CString getKeyName(LONG_PTR key) = 0;
   virtual void checkKeys() = 0;
   virtual void checkMotionKeys() = 0;
   virtual void checkDevices() = 0;
